/***
 
 @Project : Vulcan Project
 @Author : Park Dong-il (pdi1066@naver.com)
 @Date : Sep 12, 2010
 
 ***/
package newsystem.manager
{
	import com.vulcan.application.frame.itemBase.WindowItem;
	import com.vulcan.application.framework.behavior.manager.ItemBuilderManager;
	
	import document.DocumentItem;
	import document.DocumentItemBuilder;
	
	import items.component.ComponentWindowItem;
	import items.component.ComponentWindowItemBuilder;
	
	import mx.core.UIComponent;

	public class NewItemBuilderManager extends ItemBuilderManager
	{
		public function NewItemBuilderManager()
		{
		}
		/*
		public function destroy():void
		{
			_builderMap.clear();
		}
		*/
		
		/////////////////////////////////
		// window item - dynamic MVC build
		/////////////////////////////////
		
		// 열기, 생성
		override public function onWindowItemOpened(windowItem:WindowItem):void
		{
			super.onWindowItemOpened(windowItem);
			
			var instance:UIComponent = windowItem.instance;
			
			//**************************************
			// Document
			if(instance is DocumentItem ){
				createItemBuilder(windowItem, DocumentItemBuilder);
			}
			
			// component
			if(instance is ComponentWindowItem ){
				createItemBuilder(windowItem, ComponentWindowItemBuilder);
			}
		}
		
		// 닫기, 제거
		override public function onWindowItemClosed(windowItem:WindowItem):void
		{
			super.onWindowItemClosed(windowItem);
			
			var instance:UIComponent = windowItem.instance;
			
			//**************************************
			// Document
			if(instance is DocumentItem ){
				removeItemBuilder(windowItem);
			}
			
			// component
			if(instance is ComponentWindowItem ){
				removeItemBuilder(windowItem);
			}
		}
		
		
		////////////////////////////////
		// End
		////////////////////////////////
	}
}