package newsystem.procedure
{
	import com.vulcan.application.framework.NameUtils;
	import com.vulcan.application.framework.behavior.SubSystem;
	import com.vulcan.application.framework.behavior.manager.PopupContentManager;
	import com.vulcan.application.framework.behavior.popup.PopupLauncher;
	import com.vulcan.application.framework.behavior.popup.PopupStyle;
	import com.vulcan.application.framework.behavior.procedure.document.NewDocument;
	import com.vulcan.application.framework.model.data.swc.DocumentDATA;
	import com.vulcan.application.generator.info.ItemInfo;
	import com.vulcan.application.window.popup.IPopupContent;
	import com.vulcan.application.window.popup.PopupBase;
	import com.vulcan.application.window.popup.PopupBaseEvent;
	
	import flash.events.IEventDispatcher;
	
	import popups.NewPopupContentManager;
	import popups.PopupContentConstant;
	

	/**  
	 * 
	 * @Project : Vulcan Project
	 * @Author : Park Dong-il (pdi1066@naver.com)
	 * @Date : 2010. 8. 16.
	 */
	public class NewDocumentProcedure extends NewDocument
	{
		public function NewDocumentProcedure()
		{
			super();
		}
		
		/////////////////////////////////
		// 새문서 선택창 열기
		/////////////////////////////////
		
		override protected function openPopup():void
		{
			try{
				var manager:NewPopupContentManager = SubSystem(facade).managers.popupContentManager as NewPopupContentManager;
				var type:String = PopupContentConstant.TYPE_NEW_DOCUMENT_GUIDE;
				
				var content:IPopupContent = manager.getPopupContent(type);
				var style:PopupStyle = manager.getPopupStyle(type);
				
				var window:PopupBase = PopupLauncher.open(content, style);
				window.addEventListener(PopupBaseEvent.POPUP_CLOSE, onPopupClose);
				
			}catch(error:Error){
				trace(error.getStackTrace());
				procedureEnd(false, null);
			}
		}
		
		private function onPopupClose(event:PopupBaseEvent):void
		{
			IEventDispatcher(event.target).removeEventListener(PopupBaseEvent.POPUP_CLOSE, onPopupClose);
			//var window:PopupBase = PopupBase(event.target);
			
			// 리턴받은 데이터
			var documentKey:String = event.result as String;
			
			if(!documentKey || event.buttonType != PopupBaseEvent.TYPE_OK)
			{
				// process가 끝났음을 알림
				procedureEnd(true, documentKey);
				return;
			}
			
			// ItemInfo 얻어내기
			var documentInfo:ItemInfo = facade.internalAPI.getNewDocumentInfo(documentKey);
			
			// 새 문서 생성 시작
			create(documentInfo);
		}
		
		////////////////////////////////////
		// End
		////////////////////////////////////
	}
}