package popups
{
	/**  
	 * 사용예는 NewDocument 클래스 코드 참고.
	 * 
	 * @Project : Vulcan Project
	 * @Author : Park Dong-il (pdi1066@naver.com)
	 * @Date : 2010. 8. 5.
	 */
	import com.vulcan.application.framework.NameUtils;
	import com.vulcan.application.framework.behavior.SubSystem;
	import com.vulcan.application.framework.behavior.manager.PopupContentManager;
	import com.vulcan.application.framework.behavior.popup.PopupLauncher;
	import com.vulcan.application.framework.behavior.popup.PopupStyle;
	import com.vulcan.application.framework.model.data.swc.DocumentDATA;
	import com.vulcan.application.window.popup.IPopupContent;
	import com.vulcan.application.window.popup.PopupBase;
	import com.vulcan.application.window.popup.PopupBaseEvent;
	import com.vulcan.application.window.popup.PopupBaseManager;
	
	import flash.events.IEventDispatcher;
	
	import mx.core.UIComponent;
	import newsystem.procedure.PopupDocumentGuide;
	
	public class NewPopupContentManager extends PopupContentManager
	{
		public function NewPopupContentManager()
		{
			//
		}
		
		//----------------------------------
		// Override 컨텐츠 지정
		//----------------------------------
		
		/**
		 * 
		 * @param type
		 * @return 
		 * 
		 * var popupLauncher:PopupLauncher = SubSystem(facade).systemBuilder.popupLauncher;
		 * var type:String = PopupLauncher.TYPE_NEW_DOCUMENT_GUIDE;
		 * var content:IPopupContent = popupLauncher.getPopupContent(type);
		 * 
		 */
		
		// 컨텐츠가 컴포넌트일때
		override public function getPopupContent(type:String):IPopupContent
		{
			var content:IPopupContent = super.getPopupContent(type);
			if(content)
			{
				return content;
			}
			
			switch(type)
			{
				case PopupContentConstant.TYPE_NEW_DOCUMENT_GUIDE:
					content = new PopupDocumentGuide();
					break;
			}
			
			return content;
		}
		
		// 컨텐츠가 모듈일때
		override public function getPopupModule(type:String):String
		{
			var url:String;
			/*
			switch(type)
			{
				case TYPE_NEW_DOCUMENT_GUIDE:
					url = "./PopupDocumentGuide.swf";
					break;
			}
			*/
			return url;
		}
		
		//----------------------------------
		// Override 스타일 지정
		//----------------------------------
		
		override public function getPopupStyle(type:String):PopupStyle
		{
			var style:PopupStyle = super.getPopupStyle(type);
			if(style)
			{
				return style;
			}
			
			style = new PopupStyle();
			
			switch(type)
			{
				case PopupContentConstant.TYPE_NEW_DOCUMENT_GUIDE:
					
					var documentData:DocumentDATA = facade.getProxy(DocumentDATA) as DocumentDATA;
					var source:XML = documentData.getData() as XML;
					//style.modal = false;
					style.okButtonLabel = "Select";
					style.title = "Document Type Select";
					style.inputData = {
						source : source
					};
					break;
			}
			
			return style;
		}
		
		////////////////////////////////////
		// End
		////////////////////////////////////
	}
}